"use strict";
var _OverwolfPlugin_pluginName, _OverwolfPlugin_plugin, _OverwolfPlugin_loadingPromise;
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverwolfPlugin = void 0;
const tslib_1 = require("tslib");
class OverwolfPlugin {
    constructor(pluginName) {
        _OverwolfPlugin_pluginName.set(this, void 0);
        _OverwolfPlugin_plugin.set(this, null);
        _OverwolfPlugin_loadingPromise.set(this, null);
        tslib_1.__classPrivateFieldSet(this, _OverwolfPlugin_pluginName, pluginName, "f");
    }
    get plugin() {
        return tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_plugin, "f");
    }
    _loadPluginPromise() {
        return new Promise((resolve, reject) => {
            overwolf.extensions.current.getExtraObject(tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_pluginName, "f"), result => {
                if (result.success && result.object) {
                    resolve(result.object);
                }
                else {
                    const msg = `Could not load ${tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_pluginName, "f")}: ${JSON.stringify(result)}`;
                    console.warn(`OverwolfPlugin.load(): error: ${msg}`);
                    reject(msg);
                }
            });
        });
    }
    async loadPlugin() {
        if (tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_plugin, "f")) {
            return tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_plugin, "f");
        }
        if (!tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_loadingPromise, "f")) {
            tslib_1.__classPrivateFieldSet(this, _OverwolfPlugin_loadingPromise, this._loadPluginPromise(), "f");
        }
        tslib_1.__classPrivateFieldSet(this, _OverwolfPlugin_plugin, await tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_loadingPromise, "f"), "f");
        tslib_1.__classPrivateFieldSet(this, _OverwolfPlugin_loadingPromise, null, "f");
        return tslib_1.__classPrivateFieldGet(this, _OverwolfPlugin_plugin, "f");
    }
}
exports.OverwolfPlugin = OverwolfPlugin;
_OverwolfPlugin_pluginName = new WeakMap(), _OverwolfPlugin_plugin = new WeakMap(), _OverwolfPlugin_loadingPromise = new WeakMap();
//# sourceMappingURL=overwolf-plugin.js.map