"use strict";
var _SingleEvent_listeners;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SingleEvent = void 0;
const tslib_1 = require("tslib");
class SingleEvent {
    constructor() {
        _SingleEvent_listeners.set(this, new Map());
    }
    addListener(listener, ref = listener) {
        tslib_1.__classPrivateFieldGet(this, _SingleEvent_listeners, "f").set(ref, listener);
    }
    removeListener(ref) {
        tslib_1.__classPrivateFieldGet(this, _SingleEvent_listeners, "f").delete(ref);
    }
    callListener(event) {
        for (const [, listener] of tslib_1.__classPrivateFieldGet(this, _SingleEvent_listeners, "f")) {
            listener(event);
        }
    }
}
exports.SingleEvent = SingleEvent;
_SingleEvent_listeners = new WeakMap();
//# sourceMappingURL=single-event.js.map