import { EventEmitter } from './';
interface StateSubscription<StateMap> {
    on: EventEmitter<StateMap>['on'];
    off: EventEmitter<StateMap>['off'];
    addListener: EventEmitter<StateMap>['addListener'];
    removeListener: EventEmitter<StateMap>['removeListener'];
}
export declare type State<T> = T & StateSubscription<T>;
export declare function makeState<StateMap extends Record<string, any>>(name: string, initialState: StateMap, persistent?: boolean): State<StateMap>;
export declare function makeStateClient<StateMap>(name: string): State<StateMap>;
export {};
//# sourceMappingURL=store.d.ts.map